; Webmin.nsi
; Written by Philipp Ghring <pg@futureware.at>

;--------------------------------

!ifdef HAVE_UPX
!packhdr tmp.dat "upx\upx -9 tmp.dat"
!endif

!ifdef NOCOMPRESS
SetCompress off
!endif

;--------------------------------

ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"


Name "Webmin for Windows"
Caption "Webmin"
Icon "webmin.ico"
;Icon "${NSISDIR}\Contrib\Graphics\Icons\nsis1-install.ico"
OutFile "WebminInstall.exe"

SetDateSave on
SetDatablockOptimize on
CRCCheck on
SilentInstall normal
BGGradient 000000 800000 FFFFFF
InstallColors FF8080 000030
XPStyle on

InstallDir "C:\Webmin"
InstallDirRegKey HKLM "Software\Webmin" ""

CheckBitmap "${NSISDIR}\Contrib\Graphics\Checks\classic-cross.bmp"



;LicenseText "GNU GPL"
;LicenseData "bigtest.nsi"

;--------------------------------

;Page license
;Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------


AutoCloseWindow false
ShowInstDetails show

;--------------------------------
Function .onInit

IfFileExists C:\Perl\bin\perl.exe PerlInstalled
  MessageBox MB_ICONEXCLAMATION|MB_OK "Perl is not installed. Please download it from http://activestate.com/Products/activeperl/ and install it in C:\Perl"
  Quit
PerlInstalled:

IfFileExists $SYSDIR\sc.exe SCInstalled
  MessageBox MB_ICONEXCLAMATION|MB_OK "SC.exe is not installed. SC.exe should come with Windows XP and is needed by Webmin for Windows."
  Quit
SCInstalled:



  ;Extract InstallOptions files
  ;$PLUGINSDIR will automatically be removed when the installer closes
  
  InitPluginsDir
  
FunctionEnd


Section "" ; empty string makes it hidden, so would starting with -



  WriteRegStr HKLM SOFTWARE\Webmin "Install_Dir" "$INSTDIR"

  ; write uninstall strings
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Webmin" "DisplayName" "Webmin (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Webmin" "UninstallString" '"$INSTDIR\webmin-uninstall.exe"'

  SetOutPath $INSTDIR

  SetOverwrite try
  ClearErrors

  File Process.exe
  File srvany.exe
  File instsrv.exe
  !cd webmin-1.370\webmin
  File /r *
  !cd ..\..

  CreateDirectory $INSTDIR\Config
  CreateDirectory C:\Temp

  Exec 'ppm install http://www.roth.net/perl/packages/win32-daemon.ppd'


  WriteUninstaller "webmin-uninstall.exe"

  CreateDirectory "$SMPROGRAMS\Webmin"
  CreateShortCut "$SMPROGRAMS\Webmin\Webmin.lnk" "$PROGRAMFILES\Internet Explorer\iexplore.exe" "http://localhost:10000/" "$INSTDIR\webmin.ico" 0
  CreateShortCut "$SMPROGRAMS\Webmin\Uninstall Webmin.lnk" "$INSTDIR\webmin-uninstall.exe" "" "" 0
  ;MessageBox MB_YESNO "Activate Webmin now?" IDNO DoNotActivate

;  Exec '"$INSTDIR\instsrv.exe" webmin "$INSTDIR\srvany.exe"'

;  WriteRegStr HKLM "SYSTEM\CurrentControlSet\Services\webmin\Parameters" "Application" "$INSTDIR\casbase.exe Database/ table.list sync.list"
;  WriteRegStr HKLM "SYSTEM\CurrentControlSet\Services\webmin\Parameters" "AppDirectory" "$INSTDIR"


  System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("config_dir", "$INSTDIR\Config").r0'
  System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("var_dir", "$INSTDIR\Config").r0'
  System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("port", "10000").r0'
  System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("admin", "10000").r0'
  System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("ssl", "n").r0'
  System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("atboot", "y").r0'


  ExecWait "Perl $INSTDIR\setup.pl $INSTDIR\"

;  Execwait "net start webmin"
  sleep 5

  Exec '"$PROGRAMFILES\Internet Explorer\iexplore.exe" http://localhost:10000/'

  ;DoNotActivate:

SectionEnd



;--------------------------------

; Uninstaller

UninstallText "This will uninstall Webmin. Hit next to continue."
UninstallIcon "webmin.ico"
;"${NSISDIR}\Contrib\Graphics\Icons\nsis1-uninstall.ico"

Section "Uninstall"
  ;WriteRegStr HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon" "GinaDLL" ""
  ;DeleteRegValue HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon" "GinaDLL"

  Exec "net stop webmin"
  Exec "sc delete webmin"

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Webmin"
  DeleteRegKey HKLM "SOFTWARE\Webmin"
  Delete "$INSTDIR\webmin-uninstall.exe"
  Delete "$INSTDIR\instsrv.exe"
  Delete "$INSTDIR\srvany.exe"
  Delete "$INSTDIR\process.exe"

  Rmdir "C:\Temp"
  Rmdir "$INSTDIR\Config"
  Rmdir /r "$INSTDIR"

  IfFileExists "$INSTDIR" 0 NoErrorMsg
  ;  MessageBox MB_OK "Note: $INSTDIR could not be removed!" IDOK 0 ; skipped if file doesn't exist
  NoErrorMsg:

SectionEnd
